## libavif 1.2.0

=== debian/changelog ===
libavif (1.2.0-1~exp1) experimental; urgency=medium

  * New upstream release.
  * debian/watch: Introduce libargparse copy as component.
  * debian/clean, debian/rules: Correctly place libargparse copy.
  * debian/copyright: Updated.

 -- Boyuan Yang <byang@debian.org>  Mon, 03 Mar 2025 11:58:44 -0500
