=== contrib/CMakeLists.txt ===
# Copyright 2020 Joe Drago. All rights reserved.
# SPDX-License-Identifier: BSD-2-Clause

add_subdirectory(gdk-pixbuf)
