=== debian/changelog ===
libavif (1.2.1-1ubuntu1) plucky; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Disable pandoc and rav1e on i386

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 21 Mar 2025 13:49:37 +0100

libavif (1.2.1-1) unstable; urgency=medium

  * New upstream release.
  * debian/*.1: Update prebuilt man pages.

 -- Boyuan Yang <byang@debian.org>  Thu, 20 Mar 2025 14:03:55 -0400

libavif (1.2.0-1ubuntu1) plucky; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Disable pandoc and rav1e on i386

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 05 Mar 2025 08:31:42 +0100

libavif (1.2.0-1) unstable; urgency=medium

  * Upload to unstable.

 -- Boyuan Yang <byang@debian.org>  Mon, 03 Mar 2025 17:04:30 -0500
